/* WARNING, THIS FILE WAS GENERATED, DO NOT EDIT */
#ifndef TONEMAP_GLSL_GEN_HGLES3_120
#define TONEMAP_GLSL_GEN_HGLES3_120


#include "drivers/gles3/shader_gles3.h"


class TonemapShaderGLES3 : public ShaderGLES3 {

	 virtual String get_shader_name() const { return "TonemapShaderGLES3"; }
public:

	enum Conditionals {
		V_FLIP,
		USE_AUTO_EXPOSURE,
		USE_BCS,
		USE_COLOR_CORRECTION,
		USE_GLOW_FILTER_BICUBIC,
		USE_GLOW_LEVEL1,
		USE_GLOW_LEVEL2,
		USE_GLOW_LEVEL3,
		USE_GLOW_LEVEL4,
		USE_GLOW_LEVEL5,
		USE_GLOW_LEVEL6,
		USE_GLOW_LEVEL7,
		USE_REINDHART_TONEMAPPER,
		USE_FILMIC_TONEMAPPER,
		USE_ACES_TONEMAPPER,
		USE_GLOW_REPLACE,
		USE_GLOW_SCREEN,
		USE_GLOW_SOFTLIGHT,
	};

	enum Uniforms {
		EXPOSURE,
		WHITE,
		AUTO_EXPOSURE_GREY,
		GLOW_INTENSITY,
		BCS,
		GLOW_TEXTURE_SIZE,
	};

	_FORCE_INLINE_ int get_uniform(Uniforms p_uniform) const { return _get_uniform(p_uniform); }

	_FORCE_INLINE_ void set_conditional(Conditionals p_conditional,bool p_enable)  {  _set_conditional(p_conditional,p_enable); }

	#define _FU if (get_uniform(p_uniform)<0) return; ERR_FAIL_COND( get_active()!=this );

 	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, float p_value) { _FU glUniform1f(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, double p_value) { _FU glUniform1f(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, uint8_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, int8_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, uint16_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, int16_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, uint32_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, int32_t p_value) { _FU glUniform1i(get_uniform(p_uniform),p_value); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Color& p_color) { _FU GLfloat col[4]={p_color.r,p_color.g,p_color.b,p_color.a}; glUniform4fv(get_uniform(p_uniform),1,col); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Vector2& p_vec2) { _FU GLfloat vec2[2]={p_vec2.x,p_vec2.y}; glUniform2fv(get_uniform(p_uniform),1,vec2); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Vector3& p_vec3) { _FU GLfloat vec3[3]={p_vec3.x,p_vec3.y,p_vec3.z}; glUniform3fv(get_uniform(p_uniform),1,vec3); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, float p_a, float p_b) { _FU glUniform2f(get_uniform(p_uniform),p_a,p_b); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, float p_a, float p_b, float p_c) { _FU glUniform3f(get_uniform(p_uniform),p_a,p_b,p_c); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, float p_a, float p_b, float p_c, float p_d) { _FU glUniform4f(get_uniform(p_uniform),p_a,p_b,p_c,p_d); }

	_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Transform& p_transform) {  _FU

		const Transform &tr = p_transform;

		GLfloat matrix[16]={ /* build a 16x16 matrix */
			tr.basis.elements[0][0],
			tr.basis.elements[1][0],
			tr.basis.elements[2][0],
			0,
			tr.basis.elements[0][1],
			tr.basis.elements[1][1],
			tr.basis.elements[2][1],
			0,
			tr.basis.elements[0][2],
			tr.basis.elements[1][2],
			tr.basis.elements[2][2],
			0,
			tr.origin.x,
			tr.origin.y,
			tr.origin.z,
			1
		};


	glUniformMatrix4fv(get_uniform(p_uniform),1,false,matrix);


	}

		_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const Transform2D& p_transform) {  _FU

		const Transform2D &tr = p_transform;

		GLfloat matrix[16]={ /* build a 16x16 matrix */
			tr.elements[0][0],
			tr.elements[0][1],
			0,
			0,
			tr.elements[1][0],
			tr.elements[1][1],
			0,
			0,
			0,
			0,
			1,
			0,
			tr.elements[2][0],
			tr.elements[2][1],
			0,
			1
		};


	glUniformMatrix4fv(get_uniform(p_uniform),1,false,matrix);


	}

		_FORCE_INLINE_ void set_uniform(Uniforms p_uniform, const CameraMatrix& p_matrix) {  _FU

		GLfloat matrix[16];

		for (int i=0;i<4;i++) {
			for (int j=0;j<4;j++) {

				matrix[i*4+j]=p_matrix.matrix[i][j];
			}
		}

		glUniformMatrix4fv(get_uniform(p_uniform),1,false,matrix);
	}; 

#undef _FU


	virtual void init() {

		static const char* _conditional_strings[]={
			"#define V_FLIP\n",
			"#define USE_AUTO_EXPOSURE\n",
			"#define USE_BCS\n",
			"#define USE_COLOR_CORRECTION\n",
			"#define USE_GLOW_FILTER_BICUBIC\n",
			"#define USE_GLOW_LEVEL1\n",
			"#define USE_GLOW_LEVEL2\n",
			"#define USE_GLOW_LEVEL3\n",
			"#define USE_GLOW_LEVEL4\n",
			"#define USE_GLOW_LEVEL5\n",
			"#define USE_GLOW_LEVEL6\n",
			"#define USE_GLOW_LEVEL7\n",
			"#define USE_REINDHART_TONEMAPPER\n",
			"#define USE_FILMIC_TONEMAPPER\n",
			"#define USE_ACES_TONEMAPPER\n",
			"#define USE_GLOW_REPLACE\n",
			"#define USE_GLOW_SCREEN\n",
			"#define USE_GLOW_SOFTLIGHT\n",
		};

		static const char* _uniform_strings[]={
			"exposure",
			"white",
			"auto_exposure_grey",
			"glow_intensity",
			"bcs",
			"glow_texture_size",
		};

		static AttributePair *_attribute_pairs=NULL;
		static const Feedback* _feedbacks=NULL;
		static TexUnitPair _texunit_pairs[]={
			{"source",0},
			{"source_auto_exposure",1},
			{"source_glow",2},
			{"color_correction",3},
		};

		static UBOPair *_ubo_pairs=NULL;
		static const char _vertex_code[]={
10,10,108,97,121,111,117,116,40,108,111,99,97,116,105,111,110,61,48,41,32,105,110,32,104,105,103,104,112,32,118,101,99,52,32,118,101,114,116,101,120,95,97,116,116,114,105,98,59,10,108,97,121,111,117,116,40,108,111,99,97,116,105,111,110,61,52,41,32,105,110,32,118,101,99,50,32,117,118,95,105,110,59,10,10,111,117,116,32,118,101,99,50,32,117,118,95,105,110,116,101,114,112,59,10,10,118,111,105,100,32,109,97,105,110,40,41,32,123,10,10,9,103,108,95,80,111,115,105,116,105,111,110,32,61,32,118,101,114,116,101,120,95,97,116,116,114,105,98,59,10,9,117,118,95,105,110,116,101,114,112,32,61,32,117,118,95,105,110,59,10,35,105,102,100,101,102,32,86,95,70,76,73,80,10,9,117,118,95,105,110,116,101,114,112,46,121,32,61,32,49,46,48,45,117,118,95,105,110,116,101,114,112,46,121,59,10,35,101,110,100,105,102,10,10,125,10,10,		0};

		static const int _vertex_code_start=1;
		static const char _fragment_code[]={
10,35,105,102,32,33,100,101,102,105,110,101,100,40,71,76,69,83,95,79,86,69,82,95,71,76,41,10,112,114,101,99,105,115,105,111,110,32,109,101,100,105,117,109,112,32,102,108,111,97,116,59,10,35,101,110,100,105,102,10,10,10,105,110,32,118,101,99,50,32,117,118,95,105,110,116,101,114,112,59,10,10,117,110,105,102,111,114,109,32,104,105,103,104,112,32,115,97,109,112,108,101,114,50,68,32,115,111,117,114,99,101,59,32,47,47,116,101,120,117,110,105,116,58,48,10,10,117,110,105,102,111,114,109,32,102,108,111,97,116,32,101,120,112,111,115,117,114,101,59,10,117,110,105,102,111,114,109,32,102,108,111,97,116,32,119,104,105,116,101,59,10,10,35,105,102,100,101,102,32,85,83,69,95,65,85,84,79,95,69,88,80,79,83,85,82,69,10,10,117,110,105,102,111,114,109,32,104,105,103,104,112,32,115,97,109,112,108,101,114,50,68,32,115,111,117,114,99,101,95,97,117,116,111,95,101,120,112,111,115,117,114,101,59,32,47,47,116,101,120,117,110,105,116,58,49,10,117,110,105,102,111,114,109,32,104,105,103,104,112,32,102,108,111,97,116,32,97,117,116,111,95,101,120,112,111,115,117,114,101,95,103,114,101,121,59,10,10,35,101,110,100,105,102,10,10,35,105,102,32,100,101,102,105,110,101,100,40,85,83,69,95,71,76,79,87,95,76,69,86,69,76,49,41,32,124,124,32,100,101,102,105,110,101,100,40,85,83,69,95,71,76,79,87,95,76,69,86,69,76,50,41,32,124,124,32,100,101,102,105,110,101,100,40,85,83,69,95,71,76,79,87,95,76,69,86,69,76,51,41,32,124,124,32,100,101,102,105,110,101,100,40,85,83,69,95,71,76,79,87,95,76,69,86,69,76,52,41,32,124,124,32,100,101,102,105,110,101,100,40,85,83,69,95,71,76,79,87,95,76,69,86,69,76,53,41,32,124,124,32,100,101,102,105,110,101,100,40,85,83,69,95,71,76,79,87,95,76,69,86,69,76,54,41,32,124,124,32,100,101,102,105,110,101,100,40,85,83,69,95,71,76,79,87,95,76,69,86,69,76,55,41,10,10,117,110,105,102,111,114,109,32,104,105,103,104,112,32,115,97,109,112,108,101,114,50,68,32,115,111,117,114,99,101,95,103,108,111,119,59,32,47,47,116,101,120,117,110,105,116,58,50,10,117,110,105,102,111,114,109,32,104,105,103,104,112,32,102,108,111,97,116,32,103,108,111,119,95,105,110,116,101,110,115,105,116,121,59,10,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,66,67,83,10,10,117,110,105,102,111,114,109,32,118,101,99,51,32,98,99,115,59,10,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,67,79,76,79,82,95,67,79,82,82,69,67,84,73,79,78,10,10,117,110,105,102,111,114,109,32,115,97,109,112,108,101,114,50,68,32,99,111,108,111,114,95,99,111,114,114,101,99,116,105,111,110,59,32,47,47,116,101,120,117,110,105,116,58,51,10,10,35,101,110,100,105,102,10,10,10,108,97,121,111,117,116,40,108,111,99,97,116,105,111,110,32,61,32,48,41,32,111,117,116,32,118,101,99,52,32,102,114,97,103,95,99,111,108,111,114,59,10,10,35,105,102,100,101,102,32,85,83,69,95,71,76,79,87,95,70,73,76,84,69,82,95,66,73,67,85,66,73,67,10,10,47,47,32,119,48,44,32,119,49,44,32,119,50,44,32,97,110,100,32,119,51,32,97,114,101,32,116,104,101,32,102,111,117,114,32,99,117,98,105,99,32,66,45,115,112,108,105,110,101,32,98,97,115,105,115,32,102,117,110,99,116,105,111,110,115,10,102,108,111,97,116,32,119,48,40,102,108,111,97,116,32,97,41,10,123,10,32,32,32,32,114,101,116,117,114,110,32,40,49,46,48,47,54,46,48,41,42,40,97,42,40,97,42,40,45,97,32,43,32,51,46,48,41,32,45,32,51,46,48,41,32,43,32,49,46,48,41,59,10,125,10,10,102,108,111,97,116,32,119,49,40,102,108,111,97,116,32,97,41,10,123,10,32,32,32,32,114,101,116,117,114,110,32,40,49,46,48,47,54,46,48,41,42,40,97,42,97,42,40,51,46,48,42,97,32,45,32,54,46,48,41,32,43,32,52,46,48,41,59,10,125,10,10,102,108,111,97,116,32,119,50,40,102,108,111,97,116,32,97,41,10,123,10,32,32,32,32,114,101,116,117,114,110,32,40,49,46,48,47,54,46,48,41,42,40,97,42,40,97,42,40,45,51,46,48,42,97,32,43,32,51,46,48,41,32,43,32,51,46,48,41,32,43,32,49,46,48,41,59,10,125,10,10,102,108,111,97,116,32,119,51,40,102,108,111,97,116,32,97,41,10,123,10,32,32,32,32,114,101,116,117,114,110,32,40,49,46,48,47,54,46,48,41,42,40,97,42,97,42,97,41,59,10,125,10,10,47,47,32,103,48,32,97,110,100,32,103,49,32,97,114,101,32,116,104,101,32,116,119,111,32,97,109,112,108,105,116,117,100,101,32,102,117,110,99,116,105,111,110,115,10,102,108,111,97,116,32,103,48,40,102,108,111,97,116,32,97,41,10,123,10,32,32,32,32,114,101,116,117,114,110,32,119,48,40,97,41,32,43,32,119,49,40,97,41,59,10,125,10,10,102,108,111,97,116,32,103,49,40,102,108,111,97,116,32,97,41,10,123,10,32,32,32,32,114,101,116,117,114,110,32,119,50,40,97,41,32,43,32,119,51,40,97,41,59,10,125,10,10,47,47,32,104,48,32,97,110,100,32,104,49,32,97,114,101,32,116,104,101,32,116,119,111,32,111,102,102,115,101,116,32,102,117,110,99,116,105,111,110,115,10,102,108,111,97,116,32,104,48,40,102,108,111,97,116,32,97,41,10,123,10,32,32,32,32,114,101,116,117,114,110,32,45,49,46,48,32,43,32,119,49,40,97,41,32,47,32,40,119,48,40,97,41,32,43,32,119,49,40,97,41,41,59,10,125,10,10,102,108,111,97,116,32,104,49,40,102,108,111,97,116,32,97,41,10,123,10,32,32,32,32,114,101,116,117,114,110,32,49,46,48,32,43,32,119,51,40,97,41,32,47,32,40,119,50,40,97,41,32,43,32,119,51,40,97,41,41,59,10,125,10,10,117,110,105,102,111,114,109,32,105,118,101,99,50,32,103,108,111,119,95,116,101,120,116,117,114,101,95,115,105,122,101,59,10,10,118,101,99,52,32,116,101,120,116,117,114,101,50,68,95,98,105,99,117,98,105,99,40,115,97,109,112,108,101,114,50,68,32,116,101,120,44,32,118,101,99,50,32,117,118,44,105,110,116,32,112,95,108,111,100,41,10,123,10,9,102,108,111,97,116,32,108,111,100,61,102,108,111,97,116,40,112,95,108,111,100,41,59,10,9,118,101,99,50,32,116,101,120,95,115,105,122,101,32,61,32,118,101,99,50,40,103,108,111,119,95,116,101,120,116,117,114,101,95,115,105,122,101,32,62,62,32,112,95,108,111,100,41,59,10,9,118,101,99,50,32,112,105,120,101,108,95,115,105,122,101,32,61,49,46,48,47,116,101,120,95,115,105,122,101,59,10,9,117,118,32,61,32,117,118,42,116,101,120,95,115,105,122,101,32,43,32,48,46,53,59,10,9,118,101,99,50,32,105,117,118,32,61,32,102,108,111,111,114,40,32,117,118,32,41,59,10,9,118,101,99,50,32,102,117,118,32,61,32,102,114,97,99,116,40,32,117,118,32,41,59,10,10,9,102,108,111,97,116,32,103,48,120,32,61,32,103,48,40,102,117,118,46,120,41,59,10,9,102,108,111,97,116,32,103,49,120,32,61,32,103,49,40,102,117,118,46,120,41,59,10,9,102,108,111,97,116,32,104,48,120,32,61,32,104,48,40,102,117,118,46,120,41,59,10,9,102,108,111,97,116,32,104,49,120,32,61,32,104,49,40,102,117,118,46,120,41,59,10,9,102,108,111,97,116,32,104,48,121,32,61,32,104,48,40,102,117,118,46,121,41,59,10,9,102,108,111,97,116,32,104,49,121,32,61,32,104,49,40,102,117,118,46,121,41,59,10,10,9,118,101,99,50,32,112,48,32,61,32,40,118,101,99,50,40,105,117,118,46,120,32,43,32,104,48,120,44,32,105,117,118,46,121,32,43,32,104,48,121,41,32,45,32,48,46,53,41,32,42,32,112,105,120,101,108,95,115,105,122,101,59,10,9,118,101,99,50,32,112,49,32,61,32,40,118,101,99,50,40,105,117,118,46,120,32,43,32,104,49,120,44,32,105,117,118,46,121,32,43,32,104,48,121,41,32,45,32,48,46,53,41,32,42,32,112,105,120,101,108,95,115,105,122,101,59,10,9,118,101,99,50,32,112,50,32,61,32,40,118,101,99,50,40,105,117,118,46,120,32,43,32,104,48,120,44,32,105,117,118,46,121,32,43,32,104,49,121,41,32,45,32,48,46,53,41,32,42,32,112,105,120,101,108,95,115,105,122,101,59,10,9,118,101,99,50,32,112,51,32,61,32,40,118,101,99,50,40,105,117,118,46,120,32,43,32,104,49,120,44,32,105,117,118,46,121,32,43,32,104,49,121,41,32,45,32,48,46,53,41,32,42,32,112,105,120,101,108,95,115,105,122,101,59,10,10,9,114,101,116,117,114,110,32,103,48,40,102,117,118,46,121,41,32,42,32,40,103,48,120,32,42,32,116,101,120,116,117,114,101,76,111,100,40,116,101,120,44,32,112,48,44,108,111,100,41,32,32,43,10,9,9,9,32,32,32,32,103,49,120,32,42,32,116,101,120,116,117,114,101,76,111,100,40,116,101,120,44,32,112,49,44,108,111,100,41,41,32,43,10,9,9,9,103,49,40,102,117,118,46,121,41,32,42,32,40,103,48,120,32,42,32,116,101,120,116,117,114,101,76,111,100,40,116,101,120,44,32,112,50,44,108,111,100,41,32,32,43,10,9,9,9,9,32,32,32,32,32,103,49,120,32,42,32,116,101,120,116,117,114,101,76,111,100,40,116,101,120,44,32,112,51,44,108,111,100,41,41,59,10,125,10,10,10,10,35,100,101,102,105,110,101,32,71,76,79,87,95,84,69,88,84,85,82,69,95,83,65,77,80,76,69,40,109,95,116,101,120,44,109,95,117,118,44,109,95,108,111,100,41,32,116,101,120,116,117,114,101,50,68,95,98,105,99,117,98,105,99,40,109,95,116,101,120,44,109,95,117,118,44,109,95,108,111,100,41,10,10,35,101,108,115,101,10,10,35,100,101,102,105,110,101,32,71,76,79,87,95,84,69,88,84,85,82,69,95,83,65,77,80,76,69,40,109,95,116,101,120,44,109,95,117,118,44,109,95,108,111,100,41,32,116,101,120,116,117,114,101,76,111,100,40,109,95,116,101,120,44,109,95,117,118,44,102,108,111,97,116,40,109,95,108,111,100,41,41,10,10,35,101,110,100,105,102,10,10,10,118,101,99,51,32,116,111,110,101,109,97,112,95,102,105,108,109,105,99,40,118,101,99,51,32,99,111,108,111,114,44,102,108,111,97,116,32,119,104,105,116,101,41,32,123,10,10,9,102,108,111,97,116,32,65,32,61,32,48,46,49,53,59,10,9,102,108,111,97,116,32,66,32,61,32,48,46,53,48,59,10,9,102,108,111,97,116,32,67,32,61,32,48,46,49,48,59,10,9,102,108,111,97,116,32,68,32,61,32,48,46,50,48,59,10,9,102,108,111,97,116,32,69,32,61,32,48,46,48,50,59,10,9,102,108,111,97,116,32,70,32,61,32,48,46,51,48,59,10,9,102,108,111,97,116,32,87,32,61,32,49,49,46,50,59,10,10,9,118,101,99,51,32,99,111,108,116,110,32,61,32,40,40,99,111,108,111,114,42,40,65,42,99,111,108,111,114,43,67,42,66,41,43,68,42,69,41,47,40,99,111,108,111,114,42,40,65,42,99,111,108,111,114,43,66,41,43,68,42,70,41,41,45,69,47,70,59,10,9,102,108,111,97,116,32,119,104,105,116,101,116,110,32,61,32,40,40,119,104,105,116,101,42,40,65,42,119,104,105,116,101,43,67,42,66,41,43,68,42,69,41,47,40,119,104,105,116,101,42,40,65,42,119,104,105,116,101,43,66,41,43,68,42,70,41,41,45,69,47,70,59,10,10,9,114,101,116,117,114,110,32,99,111,108,116,110,47,119,104,105,116,101,116,110,59,10,10,125,10,10,118,101,99,51,32,116,111,110,101,109,97,112,95,97,99,101,115,40,118,101,99,51,32,99,111,108,111,114,41,32,123,10,9,102,108,111,97,116,32,97,32,61,32,50,46,53,49,102,59,10,9,102,108,111,97,116,32,98,32,61,32,48,46,48,51,102,59,10,9,102,108,111,97,116,32,99,32,61,32,50,46,52,51,102,59,10,9,102,108,111,97,116,32,100,32,61,32,48,46,53,57,102,59,10,9,102,108,111,97,116,32,101,32,61,32,48,46,49,52,102,59,10,9,114,101,116,117,114,110,32,99,111,108,111,114,32,61,32,99,108,97,109,112,40,40,99,111,108,111,114,42,40,97,42,99,111,108,111,114,43,98,41,41,47,40,99,111,108,111,114,42,40,99,42,99,111,108,111,114,43,100,41,43,101,41,44,118,101,99,51,40,48,46,48,41,44,118,101,99,51,40,49,46,48,41,41,59,10,125,10,10,118,101,99,51,32,116,111,110,101,109,97,112,95,114,101,105,110,100,104,97,114,116,40,118,101,99,51,32,99,111,108,111,114,44,102,108,111,97,116,32,119,104,105,116,101,41,32,123,10,10,9,114,101,116,117,114,110,32,40,32,99,111,108,111,114,32,42,32,40,32,49,46,48,32,43,32,40,32,99,111,108,111,114,32,47,32,40,32,119,104,105,116,101,41,32,41,32,41,32,41,32,47,32,40,32,49,46,48,32,43,32,99,111,108,111,114,32,41,59,10,125,10,10,118,111,105,100,32,109,97,105,110,40,41,32,123,10,10,9,118,101,99,52,32,99,111,108,111,114,32,61,32,116,101,120,116,117,114,101,76,111,100,40,115,111,117,114,99,101,44,32,117,118,95,105,110,116,101,114,112,44,32,48,46,48,41,59,10,10,35,105,102,100,101,102,32,85,83,69,95,65,85,84,79,95,69,88,80,79,83,85,82,69,10,10,9,99,111,108,111,114,47,61,116,101,120,101,108,70,101,116,99,104,40,115,111,117,114,99,101,95,97,117,116,111,95,101,120,112,111,115,117,114,101,44,105,118,101,99,50,40,48,44,48,41,44,48,41,46,114,47,97,117,116,111,95,101,120,112,111,115,117,114,101,95,103,114,101,121,59,10,35,101,110,100,105,102,10,10,9,99,111,108,111,114,42,61,101,120,112,111,115,117,114,101,59,10,10,35,105,102,32,100,101,102,105,110,101,100,40,85,83,69,95,71,76,79,87,95,76,69,86,69,76,49,41,32,124,124,32,100,101,102,105,110,101,100,40,85,83,69,95,71,76,79,87,95,76,69,86,69,76,50,41,32,124,124,32,100,101,102,105,110,101,100,40,85,83,69,95,71,76,79,87,95,76,69,86,69,76,51,41,32,124,124,32,100,101,102,105,110,101,100,40,85,83,69,95,71,76,79,87,95,76,69,86,69,76,52,41,32,124,124,32,100,101,102,105,110,101,100,40,85,83,69,95,71,76,79,87,95,76,69,86,69,76,53,41,32,124,124,32,100,101,102,105,110,101,100,40,85,83,69,95,71,76,79,87,95,76,69,86,69,76,54,41,32,124,124,32,100,101,102,105,110,101,100,40,85,83,69,95,71,76,79,87,95,76,69,86,69,76,55,41,10,35,100,101,102,105,110,101,32,85,83,73,78,71,95,71,76,79,87,10,35,101,110,100,105,102,10,10,35,105,102,32,100,101,102,105,110,101,100,40,85,83,73,78,71,95,71,76,79,87,41,10,9,118,101,99,51,32,103,108,111,119,32,61,32,118,101,99,51,40,48,46,48,41,59,10,10,35,105,102,100,101,102,32,85,83,69,95,71,76,79,87,95,76,69,86,69,76,49,10,10,9,103,108,111,119,43,61,71,76,79,87,95,84,69,88,84,85,82,69,95,83,65,77,80,76,69,40,115,111,117,114,99,101,95,103,108,111,119,44,117,118,95,105,110,116,101,114,112,44,49,41,46,114,103,98,59,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,71,76,79,87,95,76,69,86,69,76,50,10,9,103,108,111,119,43,61,71,76,79,87,95,84,69,88,84,85,82,69,95,83,65,77,80,76,69,40,115,111,117,114,99,101,95,103,108,111,119,44,117,118,95,105,110,116,101,114,112,44,50,41,46,114,103,98,59,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,71,76,79,87,95,76,69,86,69,76,51,10,9,103,108,111,119,43,61,71,76,79,87,95,84,69,88,84,85,82,69,95,83,65,77,80,76,69,40,115,111,117,114,99,101,95,103,108,111,119,44,117,118,95,105,110,116,101,114,112,44,51,41,46,114,103,98,59,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,71,76,79,87,95,76,69,86,69,76,52,10,9,103,108,111,119,43,61,71,76,79,87,95,84,69,88,84,85,82,69,95,83,65,77,80,76,69,40,115,111,117,114,99,101,95,103,108,111,119,44,117,118,95,105,110,116,101,114,112,44,52,41,46,114,103,98,59,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,71,76,79,87,95,76,69,86,69,76,53,10,9,103,108,111,119,43,61,71,76,79,87,95,84,69,88,84,85,82,69,95,83,65,77,80,76,69,40,115,111,117,114,99,101,95,103,108,111,119,44,117,118,95,105,110,116,101,114,112,44,53,41,46,114,103,98,59,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,71,76,79,87,95,76,69,86,69,76,54,10,9,103,108,111,119,43,61,71,76,79,87,95,84,69,88,84,85,82,69,95,83,65,77,80,76,69,40,115,111,117,114,99,101,95,103,108,111,119,44,117,118,95,105,110,116,101,114,112,44,54,41,46,114,103,98,59,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,71,76,79,87,95,76,69,86,69,76,55,10,9,103,108,111,119,43,61,71,76,79,87,95,84,69,88,84,85,82,69,95,83,65,77,80,76,69,40,115,111,117,114,99,101,95,103,108,111,119,44,117,118,95,105,110,116,101,114,112,44,55,41,46,114,103,98,59,10,35,101,110,100,105,102,10,10,10,9,103,108,111,119,32,42,61,32,103,108,111,119,95,105,110,116,101,110,115,105,116,121,59,10,10,35,101,110,100,105,102,10,10,10,35,105,102,100,101,102,32,85,83,69,95,82,69,73,78,68,72,65,82,84,95,84,79,78,69,77,65,80,80,69,82,10,10,9,99,111,108,111,114,46,114,103,98,32,61,32,116,111,110,101,109,97,112,95,114,101,105,110,100,104,97,114,116,40,99,111,108,111,114,46,114,103,98,44,119,104,105,116,101,41,59,10,10,35,32,105,102,32,100,101,102,105,110,101,100,40,85,83,73,78,71,95,71,76,79,87,41,10,9,103,108,111,119,32,61,32,116,111,110,101,109,97,112,95,114,101,105,110,100,104,97,114,116,40,103,108,111,119,44,119,104,105,116,101,41,59,10,35,32,101,110,100,105,102,10,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,70,73,76,77,73,67,95,84,79,78,69,77,65,80,80,69,82,10,10,9,99,111,108,111,114,46,114,103,98,32,61,32,116,111,110,101,109,97,112,95,102,105,108,109,105,99,40,99,111,108,111,114,46,114,103,98,44,119,104,105,116,101,41,59,10,10,35,32,105,102,32,100,101,102,105,110,101,100,40,85,83,73,78,71,95,71,76,79,87,41,10,9,103,108,111,119,32,61,32,116,111,110,101,109,97,112,95,102,105,108,109,105,99,40,103,108,111,119,44,119,104,105,116,101,41,59,10,35,32,101,110,100,105,102,10,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,65,67,69,83,95,84,79,78,69,77,65,80,80,69,82,10,10,9,99,111,108,111,114,46,114,103,98,32,61,32,116,111,110,101,109,97,112,95,97,99,101,115,40,99,111,108,111,114,46,114,103,98,41,59,10,10,35,32,105,102,32,100,101,102,105,110,101,100,40,85,83,73,78,71,95,71,76,79,87,41,10,9,103,108,111,119,32,61,32,116,111,110,101,109,97,112,95,97,99,101,115,40,103,108,111,119,41,59,10,35,32,101,110,100,105,102,10,10,35,101,110,100,105,102,10,10,9,47,47,114,101,103,117,108,97,114,32,76,105,110,101,97,114,32,45,62,32,83,82,71,66,32,99,111,110,118,101,114,115,105,111,110,10,9,118,101,99,51,32,97,32,61,32,118,101,99,51,40,48,46,48,53,53,41,59,10,9,99,111,108,111,114,46,114,103,98,32,61,32,109,105,120,40,32,40,118,101,99,51,40,49,46,48,41,43,97,41,42,112,111,119,40,99,111,108,111,114,46,114,103,98,44,118,101,99,51,40,49,46,48,47,50,46,52,41,41,45,97,32,44,32,49,50,46,57,50,42,99,111,108,111,114,46,114,103,98,32,44,32,108,101,115,115,84,104,97,110,40,99,111,108,111,114,46,114,103,98,44,118,101,99,51,40,48,46,48,48,51,49,51,48,56,41,41,41,59,10,10,35,105,102,32,100,101,102,105,110,101,100,40,85,83,73,78,71,95,71,76,79,87,41,10,9,103,108,111,119,32,61,32,109,105,120,40,32,40,118,101,99,51,40,49,46,48,41,43,97,41,42,112,111,119,40,103,108,111,119,44,118,101,99,51,40,49,46,48,47,50,46,52,41,41,45,97,32,44,32,49,50,46,57,50,42,103,108,111,119,32,44,32,108,101,115,115,84,104,97,110,40,103,108,111,119,44,118,101,99,51,40,48,46,48,48,51,49,51,48,56,41,41,41,59,10,35,101,110,100,105,102,10,10,47,47,103,108,111,119,32,110,101,101,100,115,32,116,111,32,98,101,32,97,100,100,101,100,32,105,110,32,83,82,71,66,32,115,112,97,99,101,32,40,116,111,103,101,116,104,101,114,32,119,105,116,104,32,105,109,97,103,101,32,115,112,97,99,101,32,101,102,102,101,99,116,115,41,10,10,9,99,111,108,111,114,46,114,103,98,32,61,32,99,108,97,109,112,40,99,111,108,111,114,46,114,103,98,44,48,46,48,44,49,46,48,41,59,10,10,35,105,102,32,100,101,102,105,110,101,100,40,85,83,73,78,71,95,71,76,79,87,41,10,9,103,108,111,119,32,61,32,99,108,97,109,112,40,103,108,111,119,44,48,46,48,44,49,46,48,41,59,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,71,76,79,87,95,82,69,80,76,65,67,69,10,10,9,99,111,108,111,114,46,114,103,98,32,61,32,103,108,111,119,59,10,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,71,76,79,87,95,83,67,82,69,69,78,10,10,9,99,111,108,111,114,46,114,103,98,32,61,32,109,97,120,40,40,99,111,108,111,114,46,114,103,98,32,43,32,103,108,111,119,41,32,45,32,40,99,111,108,111,114,46,114,103,98,32,42,32,103,108,111,119,41,44,32,118,101,99,51,40,48,46,48,41,41,59,10,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,71,76,79,87,95,83,79,70,84,76,73,71,72,84,10,10,9,123,10,10,9,9,103,108,111,119,32,61,32,40,103,108,111,119,32,42,32,48,46,53,41,32,43,32,48,46,53,59,10,9,9,99,111,108,111,114,46,114,32,61,32,32,40,103,108,111,119,46,114,32,60,61,32,48,46,53,41,32,63,32,40,99,111,108,111,114,46,114,32,45,32,40,49,46,48,32,45,32,50,46,48,32,42,32,103,108,111,119,46,114,41,32,42,32,99,111,108,111,114,46,114,32,42,32,40,49,46,48,32,45,32,99,111,108,111,114,46,114,41,41,32,58,32,40,40,40,103,108,111,119,46,114,32,62,32,48,46,53,41,32,38,38,32,40,99,111,108,111,114,46,114,32,60,61,32,48,46,50,53,41,41,32,63,32,40,99,111,108,111,114,46,114,32,43,32,40,50,46,48,32,42,32,103,108,111,119,46,114,32,45,32,49,46,48,41,32,42,32,40,52,46,48,32,42,32,99,111,108,111,114,46,114,32,42,32,40,52,46,48,32,42,32,99,111,108,111,114,46,114,32,43,32,49,46,48,41,32,42,32,40,99,111,108,111,114,46,114,32,45,32,49,46,48,41,32,43,32,55,46,48,32,42,32,99,111,108,111,114,46,114,41,41,32,58,32,40,99,111,108,111,114,46,114,32,43,32,40,50,46,48,32,42,32,103,108,111,119,46,114,32,45,32,49,46,48,41,32,42,32,40,115,113,114,116,40,99,111,108,111,114,46,114,41,32,45,32,99,111,108,111,114,46,114,41,41,41,59,10,9,9,99,111,108,111,114,46,103,32,61,32,32,40,103,108,111,119,46,103,32,60,61,32,48,46,53,41,32,63,32,40,99,111,108,111,114,46,103,32,45,32,40,49,46,48,32,45,32,50,46,48,32,42,32,103,108,111,119,46,103,41,32,42,32,99,111,108,111,114,46,103,32,42,32,40,49,46,48,32,45,32,99,111,108,111,114,46,103,41,41,32,58,32,40,40,40,103,108,111,119,46,103,32,62,32,48,46,53,41,32,38,38,32,40,99,111,108,111,114,46,103,32,60,61,32,48,46,50,53,41,41,32,63,32,40,99,111,108,111,114,46,103,32,43,32,40,50,46,48,32,42,32,103,108,111,119,46,103,32,45,32,49,46,48,41,32,42,32,40,52,46,48,32,42,32,99,111,108,111,114,46,103,32,42,32,40,52,46,48,32,42,32,99,111,108,111,114,46,103,32,43,32,49,46,48,41,32,42,32,40,99,111,108,111,114,46,103,32,45,32,49,46,48,41,32,43,32,55,46,48,32,42,32,99,111,108,111,114,46,103,41,41,32,58,32,40,99,111,108,111,114,46,103,32,43,32,40,50,46,48,32,42,32,103,108,111,119,46,103,32,45,32,49,46,48,41,32,42,32,40,115,113,114,116,40,99,111,108,111,114,46,103,41,32,45,32,99,111,108,111,114,46,103,41,41,41,59,10,9,9,99,111,108,111,114,46,98,32,61,32,32,40,103,108,111,119,46,98,32,60,61,32,48,46,53,41,32,63,32,40,99,111,108,111,114,46,98,32,45,32,40,49,46,48,32,45,32,50,46,48,32,42,32,103,108,111,119,46,98,41,32,42,32,99,111,108,111,114,46,98,32,42,32,40,49,46,48,32,45,32,99,111,108,111,114,46,98,41,41,32,58,32,40,40,40,103,108,111,119,46,98,32,62,32,48,46,53,41,32,38,38,32,40,99,111,108,111,114,46,98,32,60,61,32,48,46,50,53,41,41,32,63,32,40,99,111,108,111,114,46,98,32,43,32,40,50,46,48,32,42,32,103,108,111,119,46,98,32,45,32,49,46,48,41,32,42,32,40,52,46,48,32,42,32,99,111,108,111,114,46,98,32,42,32,40,52,46,48,32,42,32,99,111,108,111,114,46,98,32,43,32,49,46,48,41,32,42,32,40,99,111,108,111,114,46,98,32,45,32,49,46,48,41,32,43,32,55,46,48,32,42,32,99,111,108,111,114,46,98,41,41,32,58,32,40,99,111,108,111,114,46,98,32,43,32,40,50,46,48,32,42,32,103,108,111,119,46,98,32,45,32,49,46,48,41,32,42,32,40,115,113,114,116,40,99,111,108,111,114,46,98,41,32,45,32,99,111,108,111,114,46,98,41,41,41,59,10,9,125,10,10,35,101,110,100,105,102,10,10,35,105,102,32,100,101,102,105,110,101,100,40,85,83,73,78,71,95,71,76,79,87,41,32,38,38,32,33,100,101,102,105,110,101,100,40,85,83,69,95,71,76,79,87,95,83,67,82,69,69,78,41,32,38,38,32,33,100,101,102,105,110,101,100,40,85,83,69,95,71,76,79,87,95,83,79,70,84,76,73,71,72,84,41,32,38,38,32,33,100,101,102,105,110,101,100,40,85,83,69,95,71,76,79,87,95,82,69,80,76,65,67,69,41,10,9,47,47,97,100,100,105,116,105,118,101,10,9,99,111,108,111,114,46,114,103,98,43,61,103,108,111,119,59,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,66,67,83,10,10,9,99,111,108,111,114,46,114,103,98,32,61,32,109,105,120,40,118,101,99,51,40,48,46,48,41,44,99,111,108,111,114,46,114,103,98,44,98,99,115,46,120,41,59,10,9,99,111,108,111,114,46,114,103,98,32,61,32,109,105,120,40,118,101,99,51,40,48,46,53,41,44,99,111,108,111,114,46,114,103,98,44,98,99,115,46,121,41,59,10,9,99,111,108,111,114,46,114,103,98,32,61,32,109,105,120,40,118,101,99,51,40,100,111,116,40,118,101,99,51,40,49,46,48,41,44,99,111,108,111,114,46,114,103,98,41,42,48,46,51,51,51,51,51,41,44,99,111,108,111,114,46,114,103,98,44,98,99,115,46,122,41,59,10,10,35,101,110,100,105,102,10,10,35,105,102,100,101,102,32,85,83,69,95,67,79,76,79,82,95,67,79,82,82,69,67,84,73,79,78,10,10,9,99,111,108,111,114,46,114,32,61,32,116,101,120,116,117,114,101,40,99,111,108,111,114,95,99,111,114,114,101,99,116,105,111,110,44,118,101,99,50,40,99,111,108,111,114,46,114,44,48,46,48,41,41,46,114,59,10,9,99,111,108,111,114,46,103,32,61,32,116,101,120,116,117,114,101,40,99,111,108,111,114,95,99,111,114,114,101,99,116,105,111,110,44,118,101,99,50,40,99,111,108,111,114,46,103,44,48,46,48,41,41,46,103,59,10,9,99,111,108,111,114,46,98,32,61,32,116,101,120,116,117,114,101,40,99,111,108,111,114,95,99,111,114,114,101,99,116,105,111,110,44,118,101,99,50,40,99,111,108,111,114,46,98,44,48,46,48,41,41,46,98,59,10,35,101,110,100,105,102,10,10,10,9,102,114,97,103,95,99,111,108,111,114,61,118,101,99,52,40,99,111,108,111,114,46,114,103,98,44,49,46,48,41,59,10,125,10,		0};

		static const int _fragment_code_start=19;
		setup(_conditional_strings,18,_uniform_strings,6,_attribute_pairs,0, _texunit_pairs,4,_ubo_pairs,0,_feedbacks,0,_vertex_code,_fragment_code,_vertex_code_start,_fragment_code_start);
	};

};

#endif

